<template >
  <div>
    <Toast style="margin-top: 35px" />
    <div class="action">
      <div class="profile" @click="menuToggle">
        <i class="pi pi-user" style="color:white"><span class="p-ml-2" >{{user.username}}</span></i>
      </div>
      <div class="menu" >
        <h3>{{user.username.toUpperCase()}}<br><span></span></h3>
        <ul>
          <!-- <li><i class="pi pi-refresh"></i><a @click.prevent="openOrganisationUpdate">Update Organisation</a></li> -->
          <li><i class="pi pi-user-edit"></i><a @click.prevent="openDialog">Change Password</a></li>
          <li><i class="pi pi-sign-out"></i><a @click.prevent="logout">Logout</a></li>
        </ul>
      </div>
    </div>
     <form >
       <Dialog header="Change Password" :visible.sync="changePassword"
       :style="{width: '50vw'}" :modal="true" :closable=false >
       <div class="p-fluid p-formgrid p-grid">
           <div class="p-field p-col-12 p-md-6">
             <label for="oldPassword">Old Password<span style="color:red">*</span></label>
             <Password  id="oldPassword" v-model="oldPassword" :feedback="false" />
          </div>
          </div>
           <div class="p-fluid p-formgrid p-grid">
             <div class="p-field p-col-12 p-md-6">
               <label for="newPass">New Password<span style="color:red">*</span></label>
               <Password id="newPass" v-model="newPassword" toggleMask :feedback="false" ></Password>
             </div>
             <a><i class="pi pi-eye" style="margin-top: 2em;" aria-hidden="true"  @click="showPass"></i></a>
           </div>
           <div class="p-fluid p-formgrid p-grid">
             <div class="p-field p-col-12 p-md-6">
               <label for="confirmPass">Confirm Password<span style="color:red">*</span></label>
               <Password id="confirmPass" v-model="confirmPassword" toggleMask :feedback="false" ></Password>
             </div>
             <a><i class="pi pi-eye" style="margin-top: 2em;" aria-hidden="true"  @click="showConfirmPass"></i></a>
           </div>
           <hr/>
        <div class="p-fluid p-formgrid p-grid">
          <div class="p-field p-col-12 p-md-2"></div>
         <div class="p-field p-col-12 p-md-2">
             <Button class="p-button-raised p-button-rounded " @click.prevent="updatePassword" label="Update"/>
           </div>
           <div class="p-field p-col-12 p-md-2">
             <Button class="p-button-raised p-button-rounded p-button-danger " @click.prevent="cancel" label="Cancel"/>
          </div>
         </div>
     </Dialog>
      <UpdateOrganisation v-model="updateOrganisation" @cancel ="cancelUpdateOrg"/>
   </form>

 </div>
</template>

<script>
import Dialog from 'primevue/dialog'
import Toast from 'primevue/toast'
import Button from 'primevue/button'
import Password from 'primevue/password'
import UpdateOrganisation from './UpdateOrganisation.vue'
export default {
  name: 'UserMenu',
  data() {
    return {
      changePassword: false,
      oldPassword: '',
      newPassword: '',
      confirmPassword: '',
      updateOrganisation: false
    }
  },
  props: ['user'],
  methods: {
    logout() {
      localStorage.clear()
      // window.location.reload()
      this.$router.go('/login')
    },
    async updatePassword() {
      let passwordDetail = {
        oldPassword: this.oldPassword,
        newPassword: this.newPassword
      }
      if (this.newPassword === '' || this.confirmPassword === '') {
        this.$toast.add({severity: 'error', summary: '', detail: 'NewPassword and ConfirmPassword cannot be empty!', life: 10000})
        return
      }
      if (this.newPassword !== this.confirmPassword) {
        this.$toast.add({severity: 'error', summary: '', detail: 'NewPassword and ConfirmPassword does not match!', life: 10000})
        return
      }
      let response = await this.$store.dispatch('updatePassword', passwordDetail)
      if (response.data.status === 'SUCCESS') {
        this.$toast.add({severity: 'success', summary: '', detail: response.data.message, life: 10000})
        this.cancel()
      } else {
        this.$toast.add({severity: 'error', summary: '', detail: response.data.message, life: 10000})
      }
    },
    async openOrganisationUpdate() {
      this.updateOrganisation = true
    },
    cancelUpdateOrg() {
      this.updateOrganisation = false
    },
    menuToggle() {
      const toggleMenu = document.querySelector('.menu')
      toggleMenu.classList.toggle('active')
      // debugger
    },
    openDialog() {
      this.changePassword = true
    },
    cancel() {
      this.changePassword = false
      this.reset()
    },
    reset() {
      this.oldPassword = ''
      this.newPassword = ''
      this.confirmPassword = ''
    },
    showPass() {
      var x = document.getElementById('newPass')
      if (x.type === 'password') {
        x.type = 'text'
      } else {
        x.type = 'password'
      }
    },
    showConfirmPass() {
      var x = document.getElementById('confirmPass')
      if (x.type === 'password') {
        x.type = 'text'
      } else {
        x.type = 'password'
      }
    }
  },
  components: {
    Dialog,
    Button,
    Toast,
    Password,
    UpdateOrganisation
  }
}
</script>
<style scoped>
.action {
  position: fixed;
  top: 15px;
  right: 35px;
}
.action .profile{
  position: relative;
  width: 60px;
  height: 60px;
  border-radius: 50%;
  overflow: visible;
  cursor: pointer;
}

.action .profile img {
  position: absolute;
  top: 0;
  left:0;
  width: 100%;
  height: 100%;
  object-fit:cover;
}
.action .menu {
  position: absolute;
  top: 30px;
  right: -25px;
  padding: 10px 0px;
  background: #fff;
  width:200px;
  box-sizing: 0 5px 25px rgba(0,0,0,0.1);
  border-radius: 15px;
  transition: 0.5s;
  visibility: hidden;
  opacity:0;
  cursor: pointer;
}
.action .menu.active {
  visibility: visible;
  opacity:1;
}
.action .menu::before{
  content: '';
  position: absolute;
  top:-5px;
  right: 28px;
  width:20px;
  height: 20px;
  background: #fff;
  transform: rotate(45deg);
}
.action .menu h3{
  width: 100%;
  text-align: center;
  font-size: 18px;
  /* padding: 20px 0; */
  font-weight: 500;
  color:#555;
  line-height: 1.2em;
}
.action .menu h3 span {
  font-size: 14px;
  color: #cecece;
  font-weight: 400;
}
.action .menu ul li {
  list-style: none;
  padding: 10px 0;
  border-top: 1px solid rgba(0,0,0,0.05);
  display: flex;
  align-items: center;
}
.action .menu ul li i{
  max-width: 20px;
  margin-right: 10px;
  opacity: 0.5s;
  transition: 0.5s;
}
.action .menu ul li:hover i{
  opacity: 1;
}
.action .menu ul li a{
  display: inline-block;
  text-decoration: none;
  color: #555;
  font-weight: 500;
  transition: 0.5s;
}
.action .menu ul li:hover a {
  color: #ff5d94;
}
</style>
